Index: /palm/trunk/SOURCE/sor.f90
===================================================================
--- /palm/trunk/SOURCE/sor.f90	(revision 2036)
+++ /palm/trunk/SOURCE/sor.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -59,5 +59,7 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE sor( d, ddzu, ddzw, p )
- 
+
+    USE arrays_3d,                                                             &
+        ONLY:  rho_air, rho_air_zw
 
     USE grid_variables,                                                        &
@@ -101,7 +103,7 @@
 !-- Compute pre-factors.
     DO  k = 1, nz
-         f2(k) = ddzu(k+1) * ddzw(k)
-         f3(k) = ddzu(k)   * ddzw(k)
-         f1(k) = 2.0_wp * ( ddx2 + ddy2 ) + f2(k) + f3(k)
+         f2(k) = ddzu(k+1) * ddzw(k) * rho_air_zw(k)
+         f3(k) = ddzu(k)   * ddzw(k) * rho_air_zw(k-1)
+         f1(k) = 2.0_wp * ( ddx2 + ddy2 ) * rho_air(k) + f2(k) + f3(k)
     ENDDO
 
@@ -131,10 +133,10 @@
              DO  k = nzb+1, nzt
                 p(k,j,i) = p(k,j,i) + omega_sor / f1(k) * (            &
-                               ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +    &
-                               ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +    &
-                               f2(k) * p(k+1,j,i)                 +    &
-                               f3(k) * p(k-1,j,i)                 -    &
-                               d(k,j,i)                           -    &
-                               f1(k) * p(k,j,i)           )
+                           rho_air(k) * ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +   &
+                           rho_air(k) * ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +   &
+                           f2(k) * p(k+1,j,i)                              +   &
+                           f3(k) * p(k-1,j,i)                              -   &
+                           d(k,j,i)                                        -   &
+                           f1(k) * p(k,j,i)           )
              ENDDO
           ENDDO
@@ -144,11 +146,11 @@
           DO  j = nys1, nyn, 2
              DO  k = nzb+1, nzt
-                p(k,j,i) = p(k,j,i) + omega_sor / f1(k) * (            &
-                               ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +    &
-                               ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +    &
-                               f2(k) * p(k+1,j,i)                 +    &
-                               f3(k) * p(k-1,j,i)                 -    &
-                               d(k,j,i)                           -    &
-                               f1(k) * p(k,j,i)           )
+                p(k,j,i) = p(k,j,i) + omega_sor / f1(k) * (                    &
+                           rho_air(k) * ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +   &
+                           rho_air(k) * ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +   &
+                           f2(k) * p(k+1,j,i)                              +   &
+                           f3(k) * p(k-1,j,i)                              -   &
+                           d(k,j,i)                                        -   &
+                           f1(k) * p(k,j,i)           )
              ENDDO
           ENDDO
@@ -176,10 +178,10 @@
              DO  k = nzb+1, nzt
                 p(k,j,i) = p(k,j,i) + omega_sor / f1(k) * (            &
-                               ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +    &
-                               ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +    &
-                               f2(k) * p(k+1,j,i)                 +    &
-                               f3(k) * p(k-1,j,i)                 -    &
-                               d(k,j,i)                           -    &
-                               f1(k) * p(k,j,i)           )
+                           rho_air(k) * ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +   &
+                           rho_air(k) * ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +   &
+                           f2(k) * p(k+1,j,i)                              +   &
+                           f3(k) * p(k-1,j,i)                              -   &
+                           d(k,j,i)                                        -   &
+                           f1(k) * p(k,j,i)           )
              ENDDO
           ENDDO
@@ -190,10 +192,10 @@
              DO  k = nzb+1, nzt
                 p(k,j,i) = p(k,j,i) + omega_sor / f1(k) * (            &
-                               ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +    &
-                               ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +    &
-                               f2(k) * p(k+1,j,i)                 +    &
-                               f3(k) * p(k-1,j,i)                 -    &
-                               d(k,j,i)                           -    &
-                               f1(k) * p(k,j,i)           )
+                           rho_air(k) * ddx2 * ( p(k,j,i+1) + p(k,j,i-1) ) +   &
+                           rho_air(k) * ddy2 * ( p(k,j+1,i) + p(k,j-1,i) ) +   &
+                           f2(k) * p(k+1,j,i)                              +   &
+                           f3(k) * p(k-1,j,i)                              -   &
+                           d(k,j,i)                                        -   &
+                           f1(k) * p(k,j,i)           )
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2036)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -158,5 +158,5 @@
         ONLY:  e, kh, nr, nrs, nrsws, ol, pt, q, ql, qr, qrs, qrsws, qs, qsws, &
                s, shf, ss, ssws, ts, u, us, usws, v, vpt, vsws, zu, zw, z0,    &
-               z0h, z0q
+               z0h, z0q, drho_air_zw, rho_air_zw
 
     USE cloud_parameters,                                                      &
@@ -540,9 +540,9 @@
                       rib(j,i) = - g * z_mo * ( ( 1.0_wp + 0.61_wp             &
                                  * q(k+1,j,i) ) * shf(j,i) + 0.61_wp           &
-                                 * pt(k+1,j,i) * qsws(j,i) )   &
+                                 * pt(k+1,j,i) * qsws(j,i) ) * drho_air_zw(k)  &
                                  / ( uv_total(j,i)**3 * vpt(k+1,j,i) * kappa**2&
                                  + 1.0E-20_wp)
                    ELSE
-                      rib(j,i) = - g * z_mo * shf(j,i)                         &
+                      rib(j,i) = - g * z_mo * shf(j,i) * drho_air_zw(k)        &
                            / ( uv_total(j,i)**3 * pt(k+1,j,i) * kappa**2       &
                            + 1.0E-20_wp )
@@ -828,8 +828,9 @@
 !--       For a given heat flux in the surface layer:
           !$OMP PARALLEL DO
-          !$acc kernels loop private( j )
+          !$acc kernels loop private( j, k )
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                ts(j,i) = -shf(j,i) / ( us(j,i) + 1E-30_wp )
+                k   = nzb_s_inner(j,i)
+                ts(j,i) = -shf(j,i) * drho_air_zw(k) / ( us(j,i) + 1E-30_wp )
 !
 !--             ts must be limited, because otherwise overflow may occur in case
@@ -888,5 +889,6 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   qs(j,i) = -qsws(j,i) / ( us(j,i) + 1E-30_wp )
+                   k   = nzb_s_inner(j,i)
+                   qs(j,i) = -qsws(j,i) * drho_air_zw(k) / ( us(j,i) + 1E-30_wp )
                 ENDDO
              ENDDO
@@ -1025,5 +1027,6 @@
                                      + psi_m( z0(j,i) / ol_mid ) )
 
-             usws(j,i) = -usws(j,i) * 0.5_wp * ( us(j,i-1) + us(j,i) )
+             usws(j,i) = -usws(j,i) * 0.5_wp * ( us(j,i-1) + us(j,i) )         &
+                                    * rho_air_zw(k)
           ENDDO
        ENDDO
@@ -1052,5 +1055,6 @@
                                      + psi_m( z0(j,i) / ol_mid ) )
 
-             vsws(j,i) = -vsws(j,i) * 0.5_wp * ( us(j,i-1) + us(j,i) )
+             vsws(j,i) = -vsws(j,i) * 0.5_wp * ( us(j,i-1) + us(j,i) )         &
+                                    * rho_air_zw(k)
 
           ENDDO
@@ -1074,5 +1078,6 @@
              !$acc loop independent
              DO  j = nysg, nyng
-                shf(j,i) = -ts(j,i) * us(j,i)
+                k   = nzb_s_inner(j,i)
+                shf(j,i) = -ts(j,i) * us(j,i) * rho_air_zw(k)
              ENDDO
           ENDDO
@@ -1090,5 +1095,6 @@
              !$acc loop independent
              DO  j = nysg, nyng
-                qsws(j,i) = -qs(j,i) * us(j,i)
+                k   = nzb_s_inner(j,i)
+                qsws(j,i) = -qs(j,i) * us(j,i) * rho_air_zw(k)
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/tridia_solver_mod.f90
===================================================================
--- /palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 2036)
+++ /palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -129,5 +129,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu_pres, ddzw
+           ONLY:  ddzu_pres, ddzw, rho_air_zw
 
        USE kinds
@@ -140,8 +140,9 @@
 
        DO  k = 0, nz-1
-          ddzuw(k,1) = ddzu_pres(k+1) * ddzw(k+1)
-          ddzuw(k,2) = ddzu_pres(k+2) * ddzw(k+1)
+          ddzuw(k,1) = ddzu_pres(k+1) * ddzw(k+1) * rho_air_zw(k)
+          ddzuw(k,2) = ddzu_pres(k+2) * ddzw(k+1) * rho_air_zw(k+1)
           ddzuw(k,3) = -1.0_wp * &
-                       ( ddzu_pres(k+2) * ddzw(k+1) + ddzu_pres(k+1) * ddzw(k+1) )
+                       ( ddzu_pres(k+2) * ddzw(k+1) * rho_air_zw(k+1) +        &
+                         ddzu_pres(k+1) * ddzw(k+1) * rho_air_zw(k) )
        ENDDO
 !
@@ -168,5 +169,5 @@
 
           USE arrays_3d,                                                       &
-              ONLY:  tric
+              ONLY:  tric, rho_air
 
           USE constants,                                                       &
@@ -231,5 +232,5 @@
              DO  j = nys_z, nyn_z
                 DO  i = nxl_z, nxr_z
-                   tric(i,j,k) = ddzuw(k,3) - ll(i,j)
+                   tric(i,j,k) = ddzuw(k,3) - ll(i,j) * rho_air(k+1)
                 ENDDO
              ENDDO
@@ -491,5 +492,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu_pres, ddzw
+           ONLY:  ddzu_pres, ddzw, rho_air, rho_air_zw
 
        USE control_parameters,                                                 &
@@ -526,6 +527,6 @@
        DO  k = 0, nz-1
           DO  i = 0,nx
-             tri_for_1d(2,i,k) = ddzu_pres(k+1) * ddzw(k+1)
-             tri_for_1d(3,i,k) = ddzu_pres(k+2) * ddzw(k+1)
+             tri_for_1d(2,i,k) = ddzu_pres(k+1) * ddzw(k+1) * rho_air_zw(k)
+             tri_for_1d(3,i,k) = ddzu_pres(k+2) * ddzw(k+1) * rho_air_zw(k+1)
           ENDDO
        ENDDO
@@ -591,7 +592,7 @@
           DO  k = 0, nz-1
              DO  i = 0, nx
-                a = -1.0_wp * ddzu_pres(k+2) * ddzw(k+1)
-                c = -1.0_wp * ddzu_pres(k+1) * ddzw(k+1)
-                tri_for_1d(1,i,k) = a + c - l(i)
+                a = -1.0_wp * ddzu_pres(k+2) * ddzw(k+1) * rho_air_zw(k+1)
+                c = -1.0_wp * ddzu_pres(k+1) * ddzw(k+1) * rho_air_zw(k)
+                tri_for_1d(1,i,k) = a + c - l(i) * rho_air(k+1)
              ENDDO
           ENDDO
